# Benchmark of Commodity-based OLE

This project concerns commodity-based OLE generation for secure computation. It consist of a "stateless" server, that may be installed on multiple server, and two clients generating OLEs by connecting to such servers. The code is used for benchmarking with hard-coded certificates, and *is not meant for production*.

## Get Started

To quickly get started run:
- ```make```

To boot up a ("stateless") server on port 8888 execute:
- ```make server```

Now boot up Alice connecting to say five servers with given IPs:
- ```make alice -servers 5 ip1 ip2 ip3 ip4 ip5```

And afterwards boot up Bob reaching Alice at ```ipA``` on port ```4200``` with same servers:
- ```make bob -ip ipA -port 4200 -servers 5 ip1 ip2 ip3 ip4 ip5```

The two parties should now start generating secure OLEs.

## More Options

The clients will generate a single OLEs in a loop. To run multiple experiments in parallel, one can set the command line argument ```-numthread X``` to run X threads in parallel, and furthermore set ```-numparallel Y``` to make each thread generate Y OLEs in parallel. To construct OLEs over different fields, one can set ```-field F``` where $F=\{0,...,6\}$ to use a $\{32,...,2048\}$ bit field respectively.
