#include "includes.h"

#ifndef _AUTHHEADERDEF
#define _AUTHHEADERDEF

extern const size_t auth_bits;
extern const size_t auth_bytes;
extern size_t auth_export_bytes;

typedef struct {
    uint8_t index;
    mpz_t ga;
    mpz_t gb;
    mpz_t gc;
    mpz_t gr;
    mpz_t z;
} auth_t;

extern void auth_initialize();
extern auth_t auth_compute(sock_t sock);
extern auth_t* auth_vec_compute(sock_t sock, int num);
extern void auth_export(uint8_t* r, auth_t auth);
extern auth_t auth_import(uint8_t* r);
extern bool auth_verify(auth_t auth);
extern void auth_print(auth_t auth);

#endif
