#include "helpers.h"

///////////////////////////////////////////
// Types
///////////////////////////////////////////










///////////////////////////////////////////
// Console helpers
///////////////////////////////////////////

void printHex(uint8_t* a, int len) {
	for (int i = 0; i < len; i++) {
		printf("%02X", a[i]);
	}
}







// Watch
void watch_sleepms(uint64_t ms) {
#ifdef _WIN32
	Sleep((DWORD)ms);
#else
	usleep(1000*ms);
#endif
}

void watch_start(watch_t* watch) {
	clock_gettime(CLOCK_REALTIME, watch);
}

void watch_stop(watch_t* watch) {
	timespec_t now;
	clock_gettime(CLOCK_REALTIME, &now);
	timespec_diff(watch, watch, &now);
}

double watch_elapsedms(watch_t* watch) {
	return (double)watch->tv_sec * 1000 + (double)watch->tv_nsec / 1000 / 1000;
}







void timespec_diff(watch_t *result, watch_t *start, watch_t *stop) {
	if ((stop->tv_nsec - start->tv_nsec) < 0) {
		result->tv_sec = stop->tv_sec - start->tv_sec - 1;
		result->tv_nsec = stop->tv_nsec - start->tv_nsec + 1000000000;
	}
	else {
		result->tv_sec = stop->tv_sec - start->tv_sec;
		result->tv_nsec = stop->tv_nsec - start->tv_nsec;
	}
	return;
}