#include "includes.h"

// Settings
#define ENABLEENAGLE 1 // Use NAGLEs algorithm?


// Windows close
#ifdef WIN32
extern void close(sock_t sock);
#endif

// Types
typedef int sock_t;
typedef struct sockaddr_in sockaddr_t;
typedef sockaddr_t* sockaddrp_t;

// Globals
SSL_CTX* clientctx;
SSL_CTX* serverctx;

// Functions
extern void mio_initialize();
extern void mio_finalize();
extern sock_t mio_listen(int port);
extern void mio_close(sock_t sock);
extern void mio_check(sock_t sock);
extern void mio_parseaddr(sockaddrp_t addr, char* ip, int port);

extern sock_t mio_accept(sock_t sock, sockaddrp_t addr);
extern sock_t mio_connect(sockaddrp_t addr);
extern int mio_send(sock_t sock, size_t len, uint8_t* buffer);
extern int mio_recv(sock_t sock, size_t len, uint8_t* buffer);

extern sock_t mio_saccept(sock_t sock, SSL** ssl, sockaddrp_t addr);
extern sock_t mio_sconnect(SSL** ssl, sockaddrp_t addr);
extern int mio_ssend(SSL* ssl, size_t len, uint8_t* buffer);
extern int mio_srecv(SSL* ssl, size_t len, uint8_t* buffer);
extern void mio_sslfree(SSL* ssl);

// Internal helpers
int create_socket(int port);
void init_openssl();
void cleanup_openssl();
void create_client_context();
void create_server_context();
void configure_client_context();
void configure_server_context();

