#include "includes.h"

#define IP           "127.0.0.1"
#define PORT         8888

#define SEC          8
#define NUMTHREAD    1
#define NUMPARALLEL  1

#define FIELD 0

#define RAND         "Rand.bin"


void printHelp() {
	printf("No help yet, good luck!");
}

parms_t parseParameters(int argc, char *argv[]) {
	// Create default parameters
	parms_t parms;
	parms.module = 123;
	parms.ip = IP;
	parms.port = PORT;
	parms.sec = SEC;
	parms.numthread = NUMTHREAD;
	parms.numparallel = NUMPARALLEL;
	parms.field = FIELD;
	parms.rand = RAND;

	// Read phase
	char* p = argv[1];
	if (strcmp(p, "server") == 0) parms.module = MOD_SERVER;
	if (strcmp(p, "alice") == 0) parms.module = MOD_ALICE;
	if (strcmp(p, "bob") == 0) parms.module = MOD_BOB;
	if (strcmp(p, "interpolate") == 0) parms.module = MOD_INTERPOLATE;

	// Read parameters
	int i = 2;
	while (i < argc) {
		if (strcmp(argv[i], "-ip") == 0) parms.ip = argv[i + 1];
		if (strcmp(argv[i], "-port") == 0) parms.port = atoi(argv[i + 1]);
		if (strcmp(argv[i], "-sec") == 0) parms.sec = atoi(argv[i + 1]);
		if (strcmp(argv[i], "-numthread") == 0) parms.numthread = atoi(argv[i + 1]);
		if (strcmp(argv[i], "-numparallel") == 0) parms.numparallel = atoi(argv[i + 1]);
		if (strcmp(argv[i], "-rand") == 0) parms.rand = argv[i + 1];
		if (strcmp(argv[i], "-field") == 0) parms.field = atoi(argv[i + 1]);
		if (strcmp(argv[i], "-servers") == 0) {
			parms.numservers = atoi(argv[i + 1]);
			if(parms.numservers < 0) {
				parms.numservers = -parms.numservers;
				int port = atoi(argv[i + 2]);

				parms.ips = malloc(parms.numservers * sizeof(char*));
				parms.ports = malloc(parms.numservers * sizeof(int));
				for(int j=0; j<parms.numservers; ++j) {
					int ipoffset = i + 3 + j;
					parms.ips[j] = malloc(strlen(argv[ipoffset]));
					strcpy(parms.ips[j], argv[ipoffset]);
					parms.ports[j] = port;
				}
			}
			else if(parms.numservers > 0) {
				parms.ips = malloc(parms.numservers * sizeof(char*));
				parms.ports = malloc(parms.numservers * sizeof(int));
				for(int j=0; j<parms.numservers; ++j) {
					int ipoffset = i + 2 + j * 2;
					parms.ips[j] = malloc(strlen(argv[ipoffset]));
					strcpy(parms.ips[j], argv[ipoffset]);
					parms.ports[j] = atoi(argv[ipoffset+1]);
				}
			}

			
		}
		i += 2;
	}

	return parms;
}

int main(int argc, char *argv[])
{
	// Print help
	if (argc < 2) {
		printHelp();
		return 0;
	}

	// Read parameters
	parms = parseParameters(argc, argv);

	// Global initialization
	global_initialize();
		
	// Execute module
	if (parms.module == MOD_SERVER) runServer();
	if (parms.module == MOD_ALICE) runClient(true);
	if (parms.module == MOD_BOB) runClient(false);

	global_finalize();

}